%Zenei jelfeldolgozas - elso eloadas, demo 
%Copyright: Bank Balazs, BME MIT 2006-2020.


%egyszeru digitalis hullamvezeto, a hur vegein van reflexio (-1-szeres)
%a pengetes, mint haromszog alaku kezdeti kiteres modellezese
%most nem rajzolunk, hanem a kiteres idofuggvenyet rogzitjuk a pengeto helyenel


WGN=100; %a digitalis hullamvezeto (waveguide) hossza mintakban
Pick=10; %pengetesi pozicio
Pickup=20; %pickup pozicio


SampleNum=Fs; % egy teljes masodpercet kiszamolunk
output=zeros(1,SampleNum); % kinullazzuk a kimeneti vektort

UpperDL=zeros(1,WGN); %Felso kesleltetovonal (jobbra halado hullam)
LowerDL=zeros(1,WGN); %Also kesleltetovonal (balra halado hullam)

%%%%%%%%%%%%%%%%%%%
% kezdeti kiteres - pengetest modellezo haromszog
UpperDL(1:Pick)=[0:Pick-1]/(Pick-1);
UpperDL(Pick+1:WGN)=[WGN-Pick-1:-1:0]/(WGN-Pick);
LowerDL=UpperDL;

subplot(1,1,1);

plot(UpperDL+LowerDL); %kezdeti kiteres kirajzolasa
pause;



%%%%%%%%%%%%%%%%%%
%
for k=1:SampleNum,
   
   UpperDL=[0 UpperDL(1:WGN-1)]; %a kesleltetovonalak tartalmanak shiftelese
   LowerDL=[LowerDL(2:WGN) 0];
   
   Refl=-1; %visszaverodes a lezarasoknal
   UpperDL(1)=Refl*LowerDL(1);
   LowerDL(WGN)=Refl*UpperDL(WGN);

   
   Displ=UpperDL+LowerDL; %a ket haladohullam szuperpozicioja
   
   output(k)=Displ(Pickup);

end;

plot(output);
pause;

plot(output(1:1000));


% soundsc(output,Fs); % meghallgatjuk

