%Zenei jelfeldolgozas - elso eloadas, demo 
%Copyright: Bank Balazs, BME MIT 2006-2020.

%egyszeru digitalis hullamvezeto, a hur vegein van reflexio (-1-szeres)
%a pengetes, mint haromszog alaku kezdeti kiteres modellezese
%most nem rajzolunk, hanem a kiteres idofuggvenyet rogzitjuk a pengeto helyenel

%Itt mar nagyjabol a felvett hangot szeretnenk visszaallitani, azaz a frekvenciat beallitjuk, ill.
%frekvenciafuggo veszteseget rakunk a hurba, valamint a pickup-ot is modellezzuk


Fs=44100; %mintaveteli frekvencia
F0=146; %alaphang frekvenciaja


WGN=round(Fs/F0/2)+1; %a digitalis hullamvezeto (waveguide) hossza az alapfrekvencia fuggvenyeben
Pick=round(WGN*0.2); %pengetesi pozicio (most eppen a hur 20%-anal)
Pickup=round(WGN*0.25);  %pickup pozicio 

SampleNum=Fs; % egy teljes masodpercet kiszamolunk
output=zeros(1,SampleNum); % kinullazzuk a kimeneti vektort

UpperDL=zeros(1,WGN); %Felso kesleltetovonal (jobbra halado hullam)
LowerDL=zeros(1,WGN); %Also kesleltetovonal (balra halado hullam)

%%%%%%%%%%%%%%%%%%%
% kezdeti kiteres - pengetest modellezo haromszog
UpperDL(1:Pick)=[0:Pick-1]/(Pick-1);
UpperDL(Pick+1:WGN)=[WGN-Pick-1:-1:0]/(WGN-Pick);
LowerDL=UpperDL;


lpout=0;
%az alulatereszto szuro parameterei:
g=0.999;
%a=0; %ha a=0, akkor frekvenciafuggetlen a szuro (tkp. csak konstans szorzas)
a=-0.15;


%%%%%%%%%%%%%%%%%%
%
for k=1:SampleNum,
   
   UpperDL=[0 UpperDL(1:WGN-1)]; %a kesleltetovonalak tartalmanak shiftelese
   LowerDL=[LowerDL(2:WGN) 0];
   
   %%%%%%%%% elsofoku alulatereszto szurot rakunk az egyik lezerasra
   lpin=UpperDL(WGN);
   lpout=g*(1+a)*lpin-a*lpout; %itt tortenik a szures
   %%%%%%%%%

   
   UpperDL(1)=-1*LowerDL(1); %itt marad a -1-szeres visszaverodes
   LowerDL(WGN)=-lpout; %ide viszont a szuro kimenetet tesszuk

   
   Displ=UpperDL+LowerDL; %a ket haladohullam szuperpozicioja
   
   output(k)=Displ(Pickup);

end;


plot(output); %ez mar szepen lecseng
pause;


%de a pickup a hur sebessegere erzekeny, derivaljuk a kiterest
velocity=filter(10*[1 -1],1,output); 
velocity(1)=0;
plot(velocity);
pause;

%ha ezt meghallgatjuk, nagyon elesen szol - az igazi pickupoknak nem tul jo a magasfrekv. atvitele

[B,A]=butter(1,0.02); %ezet megszurjuk egy elsofoku alulateresztovel
filtered=filter(B,A,velocity);
plot(filtered);

%es ez mar egesz jol szol
% soundsc(filtered,Fs); % meghallgatjuk

